*
*        <<< ::: SOL-20 BOOT BLOCK PROGRAM - BOOT.ASM ::: >>>
*
        ORG        00100H
        XRA         A         ; CLEAR SCREEN
        OUT         0FEH
        OUT         0C8H
        CALL        PERSE
        CALL        CRLF
START:  JMP         STAR1     ; BYPASS THE MESSAGES
STAR1:  LXI         H,BEGIN   ; JUMPER OUT ORIGINAL JUMP
        SHLD        START+1
        LXI         H,MSG1    ; INSTRUCTIONS
        CALL        MSG
*
BEGIN:  LXI         H,MBLOK   ; SET UP FOR MOVE RE-LOCATION
        LXI         D,0C900H
        LXI         B,MBLOK+48
        LXI         SP,0CBE9H ; SET STACK POINTER AS EXPECTED
        XRA         A         ; FORCE SCREEN OPERATIONS
        STA         0C807H
*
MOVIT:  MOV         A,M       ; FETCH DATA TO BE MOVED
        STAX        D         ; STORE IN NEW LOCATION
        MOV         A,H       ; GET "HIGH" ADDRESS
        CMP         B         ; LAST ADDRESS?
        JNZ         MOVON     ; ... NO
        MOV         A,L       ; GET "LOW" ADDRESS
        CMP         C         ; LAST ADDRESS?
EXIT:   JZ          CLEAR     ; ... YES, MOVE IT TO 0000H
MOVON:  INX         H         ; ... NO, ADVANCE "FROM" POINTER
        INX         D         ; ADVANCE "TO" POINTER
        JMP         MOVIT
*
CLEAR:  LXI   D,00200H  ; 1ST ADDRESS TO CLEAR
        LXI   B,0A000H  ; LAST ADDRESS TO CLEAR
CLRIT:  XRA   A
        STAX  D
        MOV   A,D
        CMP   B        ; HI PART = LAST ADDRESS?
        JNZ   CLRON    ; ... NO
        JMP   FIN      ; ... YES, JUMP TO SOLOS
CLRON:  INX   D
        JMP   CLRIT
*
       DB  ' '
*
EOF:   DW 0FF3FH   ; EOF ADDRESS
       DB '              '
*
FIN:   LXI    H,0C900H   ; SOLOS CONSOLE
       SHLD   EXIT+1     ; PATCH MEM MOVE EXIT
       JMP    0C004H     ; JUMP TO SOLOS CONSOLE
*
      DB '       '
      DB '                '
MBLOK:  DB 02AH      ; LHLD EOF
        DW 00150H
        DB 044H      ; MOV  B,H
        DB 04DH      ; MOV  C,L
        DB 011H      ; LXI  D,0H
        DW 00000H
        DB 021H      ; LXI H,200H
        DW 00200H
;MOVIT:
        DB 07EH      ; MOV  A,M
        DB 012H      ; STAX D
        DB 07CH      ; MOV A,H
        DB 0B8H      ; CMP  B
        DB 0C2H      ; JNZ  MOVON
        DW 0C918H
        DB 07DH      ; MOV  A,L
        DW 0FFFEH    ; CPI  0FFH
        DB 0CAH      ; JZ   0H
        DW 00000H
;MOVON:
        DB 023H      ; INX  H
        DB 013H      ; INX  D
        DB 0C3H      ; JMP  MOVIN
        DW 0C90BH
*
      DB '*  '
      DB '*               '
      DB '*               '
      DB '*               '
      DB '*               '
      DB '*               '
      DB '*               '
*
*
*       ::: MESSAGE OUTPUT ROUTINE :::
*
*       H+L HAVE MSG'S ADDRESS, "0" ENDS MESSAGE.
*
MSG:   MOV       A,M       ; GET A CHARACTER
       CPI        0        ; END-OF-MESSAGE ?
       RZ                  ; ... YES, YOUR DONE
       MOV       B,A
       CALL      SOUT      ; OUTPUT IT
       INX       H         ; NEXT CHARACTER
       JMP       MSG
*
*---------------------------------------------------------*
*
MSG1: DB '<*>  SOL-20  BOOT LOADER FOR PROGRAMS THAT LOAD  <*>'
      DW 0A0DH
      DB '<*>  AT ADDRESS 0.  LOAD THE PROGRAM AT ADDRESS  <*>'
      DW 0A0DH
      DB '<*> 200.  0150 IS THE ADDRESS FOR THE END OF THE <*>'
      DW 0A0DH
      DB '<*> PROGRAM THAT YOU LOADED.   FOR EXAMPLE:      <*>'
      DW 0A0DH
      DB '<*>  THE LAST ADDRESS WAS 0E42.   ENTER IT PLUS  <*>'
      DW 0A0DH
      DB '<*> 200 INTO 150 BACKWARDS.  ( >EN 150: 42 10/ ) <*>'
      DW 0A0DH
      DB '<*>  THEN EXECUTE ADDRESS 0 TO RETURN TO CP/M.   <*>'
      DW 0A0DH
      DB '<*>  TYPE:  A>SAVE 16 TARG.COM  (BOOT=100 BYTES) <*>'
      DW 0A0DH
      DB '<*>  TO SAVE THE PROGRAM ON DISK WITH THE BOOT.  <*>'
      DW 0A0DH
      DB 00H
*
*-------------------------------------------------------------*
*
*
*#*   EQUATES   *#*
*
CRLF:    EQU     0C2F9H   ; LINE FEED + CARRIAGE RETURN ROUTINE
PERSE    EQU     0C0D5H   ; ERASE SCREEN
SOUT:    EQU     0C019H   ; SYSTEMS OUTPUT ROUTINE (OPORT)
         END
